| http://www.sim.no/ http://www.coin3d.org/

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoShadowGroup Class Reference

The SoShadowGroup node is a group node used for shadow rendering.Children of this node can recieve shadows, and cast shadows on other children. Use the SoShadowStyle node to control shadow casters and shadow receivers. More...

`#include <FXViz/nodes/SoShadowGroup.h>`

Inheritance diagram for SoShadowGroup:

## Public Types

enum | VisibilityFlag { ABSOLUTE_RADIUS, LONGEST_BBOX_EDGE_FACTOR, PROJECTED_BBOX_DEPTH_FACTOR }
Public Types inherited from SoSeparator
enum | CacheEnabled { OFF, ON, AUTO }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoShadowGroup (void)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | notify (SoNotList *nl)
void | enableSubgraphSearchOnNotify (const SbBool onoff)
Public Member Functions inherited from SoSeparator
| SoSeparator (void)
| SoSeparator (const int nchildren)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual SbBool | affectsState (void) const
Public Member Functions inherited from SoGroup
| SoGroup (void)
| SoGroup (int nchildren)
virtual void | addChild (SoNode *node)
virtual void | insertChild (SoNode *child, int newchildindex)
virtual SoNode * | getChild (int index) const
virtual int | findChild (const SoNode *node) const
virtual int | getNumChildren (void) const
virtual void | removeChild (int childindex)
virtual void | removeChild (SoNode *child)
virtual void | removeAllChildren (void)
virtual void | replaceChild (int index, SoNode *newchild)
virtual void | replaceChild (SoNode *oldchild, SoNode *newchild)
virtual void | pick (SoPickAction *action)
virtual void | write (SoWriteAction *action)
virtual SoChildList * | getChildren (void) const
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
uint32_t | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
static void | init (void)
static SbBool | isSupported (void)
Static Public Member Functions inherited from SoSeparator
static SoType | getClassTypeId (void)
static void | initClass (void)
static void | setNumRenderCaches (const int howmany)
static int | getNumRenderCaches (void)
Static Public Member Functions inherited from SoGroup
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFBool | isActive
SoSFFloat | intensity
SoSFFloat | precision
SoSFFloat | quality
SoSFFloat | smoothBorder
SoSFBool | shadowCachingEnabled
SoSFFloat | visibilityNearRadius
SoSFFloat | visibilityRadius
SoSFEnum | visibilityFlag
SoSFFloat | epsilon
SoSFFloat | threshold
Public Attributes inherited from SoSeparator
SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoShadowGroup ()
Protected Member Functions inherited from SoSeparator
virtual | ~SoSeparator ()
virtual SbBool | cullTest (SoState *state)
virtual SbBool | cullTest (SoGLRenderAction *action, int &cullresults)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoGroup
virtual | ~SoGroup ()
virtual SbBool | readChildren (SoInput *in)
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoSeparator
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoGroup
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoGroup
SoChildList * | children
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoShadowGroup node is a group node used for shadow rendering.

Children of this node can recieve shadows, and cast shadows on other children. Use the SoShadowStyle node to control shadow casters and shadow receivers.

Please note that all shadow casters will be rendered twice. Once to create the shadow map, and once for normal rendering. If you're having performance issues, you should consider reducing the number of shadow casters.

The algorithm used to render the shadows is Variance Shadow Maps (http://www.punkuser.net/vsm/). As an extra bonus, all geometry rendered with shadows can also be rendered with per fragment phong lighting.

This node will search its subgraph and calculate shadows for all SoSpotLight nodes. The node will use one texture unit for each spot light, so for this node to work 100%, you need to have num-spotlights free texture units while rendering the subgraph.

Currently, we only support scenes with maximum two texture units active while doing shadow rendering (unit 0 and unit 1). This is due to the fact that we emulate the OpenGL shading model in a shader program, and we're still working on creating a solution that updates the shader program during the scene graph traversal. Right now a shader program is created when entering the SoShadowGroup node, and this is used for the entire subgraph.

FILE FORMAT/DEFAULTS:

SoShadowGroup {
isActive TRUE
intensity 0.5
precision 0.5
quality 0.5
shadowCachingEnabled TRUE
visibilityRadius -1.0
visibilityFlag LONGEST_BBOX_EDGE_FACTOR
epsilon 0.00001
threshold 0.1
smoothBorder 0.0
}

Example scene graph:

#Inventor V2.1 ascii
# to get some lighting when headlight is turned off in the viewer
DirectionalLight { direction 0 0 -1 intensity 0.2 }
ShadowGroup {
quality 1 # to get per pixel lighting
ShadowStyle { style NO_SHADOWING }
SpotLight {
location -8 -8 8.0
direction 1 1 -1
cutOffAngle 0.35
dropOffRate 0.7
}
ShadowStyle { style CASTS_SHADOW_AND_SHADOWED }
Separator {
Complexity { value 1.0 }
Material { diffuseColor 1 1 0 specularColor 1 1 1 shininess 0.9 }
Shuttle { translation0 -3 1 0 translation1 3 -5 0 speed 0.25 on TRUE }
Translation { translation -5 0 2 }
Sphere { radius 2.0 }
}
Separator {
Material { diffuseColor 1 0 0 specularColor 1 1 1 shininess 0.9 }
Shuttle { translation0 0 -5 0 translation1 0 5 0 speed 0.15 on TRUE }
Translation { translation 0 0 -3 }
Cube { depth 1.8 }
}
Separator {
Material { diffuseColor 0 1 0 specularColor 1 1 1 shininess 0.9 }
Shuttle { translation0 -5 0 0 translation1 5 0 0 speed 0.3 on TRUE }
Translation { translation 0 0 -3 }
Cube { }
}
ShadowStyle { style SHADOWED }
Coordinate3 { point [ -10 -10 -3, 10 -10 -3, 10 10 -3, -10 10 -3 ] }
Material { specularColor 1 1 1 shininess 0.9 }
Complexity { textureQuality 0.1 }
Texture2 { image 2 2 3 0xffffff 0x225588 0x225588 0xffffff }
Texture2Transform { scaleFactor 4 4 }
FaceSet { numVertices 4 }
}

Since
  Coin 2.5

## Constructor & Destructor Documentation

## ◆ SoShadowGroup()

SoShadowGroup::SoShadowGroup | ( | void |  | ) |

Default constructor.

## ◆ ~SoShadowGroup()

SoShadowGroup::~SoShadowGroup | ( |  | ) |

protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType SoShadowGroup::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Reimplemented from SoSeparator.

## ◆ getFieldData()

const SoFieldData * SoShadowGroup::getFieldData | ( | void |  | ) | const

protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoSeparator.

## ◆ isSupported()

SbBool SoShadowGroup::isSupported | ( | void |  | ) |

static

Reports whether or not the shadow nodes can be used successfully on the current system.

The result will depend on the specific qualities of the graphics card and OpenGL driver on the system.

An important note about this function:

The API design of this function has a serious shortcoming, as features of OpenGL should be tested within an OpenGL context, and this function does not provide any means of specifying the context. It is implemented in this manner to match the function signature in TGS Inventor, for compatibility reasons.

(A temporary offscreen OpenGL context is set up for the feature tests. This should usually be sufficient to decide whether or not the graphics driver / card supports the features needed for rendering shadows.)

Since
  Coin 3.1

## ◆ GLRenderBelowPath()

void SoShadowGroup::GLRenderBelowPath | ( | SoGLRenderAction * | action | ) |

virtual

SGI Open Inventor v2.1 obsoleted support for SoGLRenderAction::addMethod(). Instead, GLRender() might be called directly, and to optimize traversal, the SoSeparator node calls GLRenderBelowPath whenever the path code is BELOW_PATH or NO_PATH (path code is guaranteed not to change). To be compatible with SGI's Inventor (and thereby also TGS') we have chosen to follow their implementation in this respect.

SoSeparator::GLRenderBelowPath() do not traverse its children using SoChildList::traverse(), but calls GLRenderBelowPath() directly for all its children.

Reimplemented from SoSeparator.

## ◆ GLRenderInPath()

void SoShadowGroup::GLRenderInPath | ( | SoGLRenderAction * | action | ) |

virtual

Implements the SoAction::IN_PATH traversal method for the rendering action.

Reimplemented from SoSeparator.

## ◆ notify()

void SoShadowGroup::notify | ( | SoNotList * | l | ) |

virtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoSeparator.

## ◆ enableSubgraphSearchOnNotify()

void SoShadowGroup::enableSubgraphSearchOnNotify | ( | const SbBool | onoff | ) |

By default, the SoShadowGroup node will search its subgraph for new spot lights whenever a group node under it is touched. However, this might lead to bad performance in some cases so it's possible to disable this feature using this method. If you do disable this feature, make sure you enable it again before inserting a new spot light, or insert all spot lights in the scene graph before you render the scene once, and just set "on" to FALSE if you want to toggle spot lights on/off on the fly.

Since
  Coin 2.6

## Member Data Documentation

## ◆ isActive

SoSFBool SoShadowGroup::isActive

Use this field to turn shadow rendering for the subgraph on/off. Default value is TRUE.

## ◆ intensity

SoSFFloat SoShadowGroup::intensity

Not used yet. Provided for TGS Inventor compatibility.

## ◆ precision

SoSFFloat SoShadowGroup::precision

Use to calculate the size of the shadow map. A precision of 1.0 means the maximum shadow buffer size will be used (typically 2048x2048 on current graphics cards). Default value is 0.5.

## ◆ quality

SoSFFloat SoShadowGroup::quality

Can be used to tune the shader program complexity. A higher value will mean that more calculations are done per-fragment instead of per-vertex. Default value is 0.5.

## ◆ smoothBorder

SoSFInt32 SoShadowGroup::smoothBorder

SoShadowGroup::VisibilityFlag SoShadowGroup::ABSOLUTE_RADIUS

The absolute values of visibilityNearRadius and visibilityRadius will be used.

SoShadowGroup::VisibilityFlag SoShadowGroup::LONGEST_BBOX_EDGE_FACTOR

The longest bbox edge will be used to determine near and far clipping planes.

SoShadowGroup::VisibilityFlag SoShadowGroup::PROJECTED_BBOX_DEPTH_FACTOR

The bbox depth (projected to face the camera) will be used to calculate the clipping planes.

We have some problems with this feature so it's not supported at the moment.

Used to add shadow border smoothing. This is currently done as a post processing step on the shadow map. The algorithm used is Gauss Smoothing, but in the future we'll probably change this, and use a summed area sampling merhod instead. The value should be a number between 0 (no smoothing), and 1 (max smoothing).

If you want to enable smoothing, choosing a low value (~0.1) works best in the current implementation.

Default value is 0.0.

## ◆ shadowCachingEnabled

SoSFBool SoShadowGroup::shadowCachingEnabled

Not used yet. Provided for TGS Inventor compatibility.

## ◆ visibilityNearRadius

SoSFFloat SoShadowGroup::visibilityNearRadius

Can be used to manually set the near clipping plane of the shadow maps. If a negative value is provided, the group will calculate a near plane based on the bounding box of the children. Default value is -1.0.

See also
  visibilityFlag

## ◆ visibilityRadius

SoSFFloat SoShadowGroup::visibilityRadius

Can be used to manually set the far clipping plane of the shadow maps. If a negative value is provided, the group will calculate a near plane based on the bounding box of the children. Default value is -1.0.

See also
  visibilityFlag

## ◆ visibilityFlag

SoSFEnum SoShadowGroup::visibilityFlag

Determines how visibilityRadius and visibilitNearRadius is used to calculate near and far clipping planes for the shadow volume.

## ◆ epsilon

SoSFFloat SoShadowGroup::epsilon

Epsilon is used to offset the shadow map depth from the model depth. Should be set to as low a number as possible without causing flickering in the shadows or on non-shadowed objects. Default value is 0.00001.

## ◆ threshold

SoSFFloat SoShadowGroup::threshold

Can be used to avoid light bleeding in merged shadows cast from different objects.

A threshold to completely eliminate all light bleeding can be computed from the ratio of overlapping occluder distances from the light's perspective. See http://forum.beyond3d.com/showthread.php?t=38165 for a discussion about this problem.

The documentation for this class was generated from the following files:

- SoShadowGroup.h
- SoShadowGroup.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.